import { Component, EventEmitter, Input, Output, OnInit } from '@angular/core';
import { ToastrService } from 'ngx-toastr';
export interface DataModel {
  code: string,
  behaviorIndicators: string[],
  assessmentTools: AssessmentToolsModal[][],
  curriculum: CurriculumModal[]
}
export interface AssessmentToolsModal {
  code: string,
  name: string,
  nameShow: string,
}
export interface CurriculumModal {
  code: string,
  name: string
}
@Component({
  selector: 'app-edit-group-indicators',
  templateUrl: './edit-group-indicators.html',
  styleUrls: ['./edit-group-indicators.scss']
})
export class EditGroupIndicators implements OnInit {
  @Output() sendEdit: EventEmitter<boolean> = new EventEmitter<boolean>();
  search = ""
  currentPage = 1
  page = Array.from({ length: 1 }, (_, i) => i + 1);
  dataList: DataModel[] = [
    {
      code: "1", behaviorIndicators: ["asdasdasdasdasdasdasdasdasdasddsdasdasdasdasdasdasdasdasdasdsad", "2", "3"], assessmentTools: [[
        { code: "O", nameShow: "O", name: "O" },
        { code: "A", nameShow: "A", name: "A" },
        { code: "D", nameShow: "D", name: "D" },
        { code: "O", nameShow: "O", name: "O" },
        { code: "A", nameShow: "A", name: "A" },
        { code: "D", nameShow: "D", name: "D" }
      ],[],[
        { code: "O", nameShow: "O", name: "O" },
      ]], curriculum: [{ code: "1", name: "1" }, { code: "asdasdasdasdasdasdasdasdasdasddsdasdasdasdasdasdasdasdasdasdsad", name: "asdasdasdasdasdasdasdasdasdasddsdasdasdasdasdasdasdasdasdasdsad" }, { code: "3", name: "3" }]
    },
    { code: "2", behaviorIndicators: [], assessmentTools: [], curriculum: [] },
    { code: "3", behaviorIndicators: [], assessmentTools: [], curriculum: [] }
  ]
  dataSelect?: DataModel
  assessmentToolsSelect: number = -1

  searchModal = ""
  currentPageModal = 1
  pageModal = Array.from({ length: 1 }, (_, i) => i + 1);

  assessmentToolsList: AssessmentToolsModal[] = [
    { code: "01", nameShow: "O", name: "แบบสังเกต" },
    { code: "02", nameShow: "D", name: "แบบการปฏิบัติงาน" },
    { code: "03", nameShow: "P", name: "การบันทึก/เอกสาร" },
    { code: "04", nameShow: "I", name: "การสัมภาษณ์" },
    { code: "05", nameShow: "T", name: "แบบทดสอบ" }
  ]


  curriculumList: CurriculumModal[] = [
    { code: "CC-01-01", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ O1-O2" },
    { code: "CC-01-02", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ O3-O4" },
    { code: "CC-01-03", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ S1-S2" },
    { code: "CC-01-04", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ S3-S4" },
    { code: "CC-01-05", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ M1-M2" },
    { code: "CC-01-06", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ M3-M4" }
  ]


  ngOnInit() {
    this.searchChange()
  }
  onEdit() {
    this.sendEdit.emit(false);
  }
  searchChange() {
    this.currentPage = 1;
    const filteredData = this.dataListFilter();
    this.page = Array.from({ length: Math.ceil(filteredData.length / 10) }, (_, i) => i + 1);
  }
  dataListFilter() {
    return this.dataList.filter(x => {
      const match = x.code.includes(this.search);
      return match;
    });
  }

  assessmentToolsModalSearchChange() {
    this.currentPageModal = 1;
    const filteredData = this.assessmentToolsListFilter();
    this.pageModal = Array.from({ length: Math.ceil(filteredData.length / 10) }, (_, i) => i + 1);
  }
  assessmentToolsListFilter() {
    const dataList = (this.assessmentToolsSelect > -1 && this.dataSelect) ? this.dataSelect.assessmentTools[this.assessmentToolsSelect] : this.assessmentToolsList
    return dataList.filter(x => {
      const match = x.code.includes(this.searchModal) || x.name.includes(this.searchModal);
      return match;
    });
  }
  curriculumModalSearchChange() {
    this.currentPageModal = 1;
    const filteredData = this.curriculumListFilter();
    this.pageModal = Array.from({ length: Math.ceil(filteredData.length / 10) }, (_, i) => i + 1);
  }
  curriculumListFilter() {
    const dataList = this.curriculumList
    return dataList.filter(x => {
      const match = x.code.includes(this.searchModal) || x.name.includes(this.searchModal);
      return match;
    });
  }
  // activeTab: string = 'tab1';
  // isChecked: boolean = false;

  // // ข้อมูลที่จะใช้แสดงในตาราง
  // @Input() items: any[] = [
  //   ['1', '', 'CC'],
  //   ['2', '', 'MC'],
  //   ['3', '', 'PC']
  // ];

  // // ฟังก์ชันในการเปลี่ยนแท็บ
  // changeTab(tab: { id: string, text: string }) {
  //   this.activeTab = tab.id;
  // }

  // onEdit() {
  //   this.sendEdit.emit(false);
  // }

  // // ฟังก์ชันในการบันทึกข้อมูลที่แก้ไข
  // saveData(event: any, id: any): void {
  //   const updatedText = event.target.innerText;  // ข้อความที่พิมพ์เข้าไป

  //   // เก็บข้อมูลใน localStorage
  //   localStorage.setItem(`item-${id}`, updatedText);

  //   // ฟังก์ชันอัปเดตข้อมูล (หากต้องการส่งไปยัง API)
  //   this.updateItem(id, updatedText);
  // }

  // // ฟังก์ชันในการอัพเดตข้อมูล
  // updateItem(id: any, updatedText: string): void {
  //   // ส่งข้อมูลไปยัง API เพื่อบันทึกข้อมูลในฐานข้อมูล
  //   // ตัวอย่างเช่น:
  //   // this.myService.updateItem(id, updatedText).subscribe(response => {
  //   //   this.showSuccessEdit(); // เรียกฟังก์ชันแจ้งเตือน
  //   // });
  // }

  // // เมื่อหน้าเว็บโหลดใหม่ดึงข้อมูลจาก localStorage
  // ngOnInit(): void {
  //   this.items.forEach(item => {
  //     const savedText = localStorage.getItem(`item-${item[0]}`);
  //     if (savedText) {
  //       item[1] = savedText;  // ใช้ข้อมูลที่เก็บไว้
  //     }
  //   });
  // }

  // modalOptions: {
  //   [nameModal: string]: {
  //     isModalOpen: boolean;
  //     modalSize: string;
  //     backdropClose: boolean;
  //   };
  // } = {
  //     "add": { isModalOpen: false, modalSize: 'm', backdropClose: true },
  //     "edit": { isModalOpen: false, modalSize: 'm', backdropClose: true }
  //   };

  // openModal(name: string, size: string, closeOnBackdrop?: boolean) {
  //   this.modalOptions[name].modalSize = size;
  //   this.modalOptions[name].backdropClose = closeOnBackdrop || false;
  //   this.modalOptions[name].isModalOpen = true;
  //   this.currentModal = name;
  //   document.body.style.overflow = 'hidden';
  // }

  // closeModal(name: string) {
  //   this.modalOptions[name].isModalOpen = false;
  //   if (!this.isAnyModalOpen()) {
  //     document.body.style.overflow = '';
  //   }
  // }

  // isAnyModalOpen(): boolean {
  //   return Object.values(this.modalOptions).some(modal => modal.isModalOpen);
  // }

  // // ฟังก์ชันสำหรับการเพิ่ม ลบ หรือแก้ไข ข้อมูล
  // addUser() {

  // }


  // currentModal = "";

  // constructor(private toastr: ToastrService) { }

  // // แสดงข้อความแจ้งเตือนเมื่อการบันทึกสำเร็จ
  // showSuccess() {
  //   this.toastr.success('บันทึกข้อมูลสำเร็จ', 'เเจ้งเตือน', { timeOut: 3000, positionClass: 'toast-top-right' });
  // }

  // showSuccessEdit() {
  //   this.toastr.success('เเก้ไขข้อมูลสำเร็จ', 'เเจ้งเตือน', { timeOut: 3000, positionClass: 'toast-top-right' });
  // }

  // showSuccessDelete() {
  //   this.toastr.success('ลบข้อมูลสำเร็จ', 'เเจ้งเตือน', { timeOut: 3000, positionClass: 'toast-top-right' });
  // }
}
